# gip

[![Build Status](https://travis-ci.org/dalance/gip.svg?branch=master)](https://travis-ci.org/dalance/gip)
[![Crates.io](https://img.shields.io/crates/v/gip.svg)](https://crates.io/crates/gip)
[![Docs.rs](https://docs.rs/gip/badge.svg)](https://docs.rs/gip)
[![codecov](https://codecov.io/gh/dalance/gip/branch/master/graph/badge.svg)](https://codecov.io/gh/dalance/gip)

**gip** is a command-line tool and Rust library to check global IP address.

## Install
Download from [release page](https://github.com/dalance/gip/releases/latest), and extract to the directory in PATH.

Alternatively you can install by [cargo](https://crates.io).

```
cargo install gip
```

## Usage

```
gip 0.3.2-pre
dalance <dalance@gmail.com>
A library and command-line frontend to check global IP address

USAGE:
    gip [FLAGS] [OPTIONS]

FLAGS:
    -4, --v4         IPv4 address ( default )
    -6, --v6         IPv6 address
    -p, --plane      Show by plane text ( default )
    -s, --string     Show by plane text without line break
    -j, --json       Show by JSON
    -l, --list       Show provider list
    -v, --verbose    Show verbose message
    -h, --help       Prints help information
    -V, --version    Prints version information

OPTIONS:
        --timeout <timeout>      Timeout per each provider by milliseconds [default: 1000]
        --json-key <json_key>    Key string of JSON format [default: ip]
        --proxy <proxy>          Proxy for HTTP access ( "host:port" )
```

## Providers
Currently built-in service providers are the followings.

- [inet-ip.info](http://inet-ip.info) ( v4 only )
- [ipify.org](http://ipify.org) ( v4 only )
- [httpbin.org](http://httpbin.org) ( v4 only )
- [ipv6-test.com](http://ipv6-test.com) ( v4 /v6 )
- [ident.me](http://api.ident.me) ( v4 / v6 )

If you want to change providers, providers can be set by `$HOME/.gip.toml` like the following.

```
[[providers]]
    name    = "inet-ip.info"
    ptype   = "IPv4"
    format  = "Plane"
    url     = "http://inet-ip.info/ip"
    key     = []

[[providers]]
    name    = "httpbin.org"
    ptype   = "IPv4"
    format  = "Json"
    url     = "http://httpbin.org/ip"
    key     = ["origin"]
```

## Library

**gip** is provided as Rust library.

```Cargo.toml
gip = "*"
```

[Documentation](https://docs.rs/gip)
